/*-----------------------------------------------------------------
 * THIS CODE FOR DEMONSTRATION PURPOSES ONLY
 * RELEASED INTO THE PUBLIC DOMAIN
 *
 * Simple key acquisition patch for ROM version 2.0.300 - 2.0.305
 */
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>


#ifndef O_BINARY
#define O_BINARY 0
#endif

typedef unsigned char uchar;
uchar buf[256];


typedef struct patch
{
    int position;
    unsigned long int old;
    unsigned long int new;
} patch;


patch patches[] = {
    {   4,0xe3a00b02,0xe3a00b04},
    {0x18,0xe3a07003,0xe59f7044},
    {0x38,0x1a00000a,0xe1a00000},
    {0x44,0xe1a05000,0xe3a05b04},
    {0x48,0xe3750001,0xe2877001},
    {0x4C,0x03a04075,0xe35700ff},
    {0x50,0x0a000004,0x03a07000},
    {0x54,0xe3550000,0xe58f7008},
    {0x58,0x03a04076,0xe3540000},
    {0x5C,0x0a000001,0x1afffff1},
    {0x60,0xe3550b02,0xea000006},
    {0x64,0x83a0405e,0x00000000},
    {0x80,0xe3a00b02,0xe3a00b04},
    {0x9C,0xe2861004,0xe2861000}
};

int try_patch(int fd,unsigned long int offset, int npatches, patch * patches) {
    int i;

    if (lseek (fd, offset, SEEK_SET) == -1) {
        fprintf (stderr, "Seek failed.\n");
        return -1; 
    }
    if (read (fd, buf, 256) != 256) {
        fprintf (stderr, "Read failed.\n");
        return -1; 
    }
    for (i = 0; i < npatches; i++) {
        unsigned long int old;

        old = *(unsigned long int *)(buf + patches[i].position);
        if (old != patches[i].old) { 
            return patches[i].position;
        }
        *(unsigned long int *)(buf + patches[i].position) = patches[i].new;
    } 

    if (lseek (fd, offset, SEEK_SET) == -1) {
        fprintf (stderr, "Seek failed.\n");
        return -1; 
    }
    if (write (fd, buf, 256) != 256) {
        fprintf (stderr, "write failed.\n");
        return -1;
    }
    return 0;
}

int
main (int argc, char **argv) {
  int fd;
  int x;

  if (argc < 2)
    exit (-1);
  fd = open (argv[1], O_BINARY | O_RDWR);
  if (fd < 0) {
    fprintf (stderr, "Unable to open \"%s\".\n", argv[1]);
    exit (-1);
  }

    x = try_patch(fd,0x7EF10,sizeof(patches)/sizeof(patches[0]),patches);
    if (x != 0) {
        printf("Patch for Version 2.0.300 failed: %d (%x)\n", x, x);
        x = try_patch(fd,0x7d258,sizeof(patches)/sizeof(patches[0]),patches);
    } 
    if (x != 0) {
        printf("Patch for Version 2.0.303 failed: %d (%x)\n", x, x);
        x = try_patch(fd,0x7ccdc,sizeof(patches)/sizeof(patches[0]),patches);
    } 
    if (x != 0) {
        printf("Patch for Version 2.0.305 failed: %d (%x)\n", x, x);
        fprintf(stderr,"I DON'T RECOGNIZE THIS ROM VERSION......\n");
        exit(-1);
    } 
    
    printf ("KEYPATCH SUCCESS\n");
    exit (0);
}
